#!/usr/bin/perl

use CGI;

$CGI::POST_MAX = 100;
$CGI::DISABLE_UPLOADS = 1;

BEGIN {
	if ($ENV{QUERY_STRING} =~ /^instance=(\S+)$/) {
		$ENV{INSTANCE_NAME} = $1;
	}
}

use AbsenceConfig;
use AbsenceDB;
use AbsenceAuthentication;
use AbsenceAuthorization;

my $DEF_CHUNKSIZE	= 6;
my $MAIN_SCRIPT		= AbsenceConfig::fetch('main_script');
my $MANAGE_SCRIPT	= AbsenceConfig::fetch('manage_script');
#my $CONTROL_SCRIPT	= AbsenceConfig::fetch('control_script');
my $TOP				= AbsenceConfig::fetch('data_dir_rel');
my $VERSION			= '1.4';
my $COOKIE_NAME		= 'absence';

if (exists($ENV{INSTANCE_NAME})){
	$MAIN_SCRIPT .= "?instance=$ENV{INSTANCE_NAME}";
	$COOKIE_NAME = "absence-$ENV{INSTANCE_NAME}";
}

my ($month, $year) = (localtime(time))[4,5];
$month++;
$year += 1900;
my $chunksize = $DEF_CHUNKSIZE;

my $q = new CGI;
$q->import_names;

#-----------------------------------------------------------------
# first, authenticate if necessary
#-----------------------------------------------------------------
my $AUTH_USER = AbsenceAuthentication::checkAuthentication($q);

my %cook = $q->cookie($COOKIE_NAME);

if (exists($cook{chunksize})) {
	$chunksize = $cook{chunksize};
}

my $def_group_id = '';
if (exists($cook{group_id})) {
	$def_group_id = $cook{group_id};
}

if (exists($cook{month})) {
	$month = $cook{month};
	$year = $cook{year};
}

print $q->header(),
	$q->start_html(
		-title		=> 'Absence',
		-target		=> 'display',
		-BGCOLOR	=> '#ff9081',
	);

if ((AbsenceConfig::fetch('authentication') eq 'yes') &&
	!defined($ENV{REMOTE_USER}))
{
	print "<H3>NOT AUTHENTICATED</H3>\n", $q->end_html;
	exit;
}

print $q->startform(
	-name	=> 'AbsenceControl',
	-action	=> $MAIN_SCRIPT,
	-method => 'POST',
);

#print "AU:$AUTH_USER ";

print "Show";
print $q->popup_menu(
	-name	=> 'chunksize',
	-values	=> [1..15],
	-default=> $chunksize,
);
print "Months. Start with ";
print $q->popup_menu(
	-name	=> 'start_month',
	-values	=> [1..12],
	-default=> $month,
);
print $q->popup_menu(
	-name	=> 'start_year',
	-values	=> [2002..2010],
	-default=> $year,
);
print $q->submit(-value => 'SHOW ME!');
print $q->submit(-name => 'jump',	-value => 'Previous');
print $q->submit(-name => 'jump',	-value => 'Next');
print "Group";
my @groups = AbsenceAuthorization::getReadGroups($AUTH_USER);
my $labref;
my $def;
foreach my $group_id (@groups) {
	$name = AbsenceDB::getGroup($group_id, 'name');
	$labref->{$group_id} = $name;
}
my $js_submit = q[JavaScript:document.AbsenceControl.submit();];

my @sorted = sort {lc($labref->{$a}) cmp lc($labref->{$b})} @groups;
print $q->popup_menu(
	-name		=> 'group_id',
	-values		=> \@sorted,
	-default	=> $def_group_id,
	-labels		=> $labref,
	-onChange	=> $js_submit,
);

my $inst_str;
if (exists($ENV{INSTANCE_NAME})) {
	$inst_str = qq[?instance=$ENV{INSTANCE_NAME}];
}
print qq[&nbsp;&nbsp;<A HREF="$MANAGE_SCRIPT$inst_str">Manage</A><BR>\n];
print $q->endform;
#print "<BR>cookie_name = [$COOKIE_NAME]\n";


print $q->end_html;
